package com.zhongzheng.modules.user.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.zhongzheng.modules.bank.vo.QuestionVo;
import com.zhongzheng.modules.user.bo.UserExamRecordQueryBo;
import com.zhongzheng.modules.user.bo.UserExamWrongRecordAddBo;
import com.zhongzheng.modules.user.bo.UserExamWrongRecordEditBo;
import com.zhongzheng.modules.user.bo.UserExamWrongRecordQueryBo;
import com.zhongzheng.modules.user.domain.UserExamWrongRecord;
import com.zhongzheng.modules.user.vo.UserExamRecordVo;
import com.zhongzheng.modules.user.vo.UserExamWrongRecordVo;

import java.util.Collection;
import java.util.List;

/**
 * 用户我的题库错题记录Service接口
 *
 * @author hjl
 * @date 2021-12-15
 */
public interface IUserExamWrongRecordService extends IService<UserExamWrongRecord> {
	/**
	 * 查询单个
	 * @return
	 */
	UserExamWrongRecordVo queryById(Long wrongId);

	Long recordNum(UserExamWrongRecordQueryBo bo);

	/**
	 * 查询列表
	 */
	List<UserExamWrongRecordVo> queryList(UserExamWrongRecordQueryBo bo);

	List<UserExamWrongRecordVo> selectList(UserExamWrongRecordQueryBo bo);

	List<UserExamWrongRecordVo> selectQuestionList(UserExamWrongRecordQueryBo bo);

	List<UserExamWrongRecordVo> selectTypeNum(UserExamWrongRecordQueryBo bo);

	List<UserExamWrongRecordVo> selectTypeQuestionList(UserExamWrongRecordQueryBo bo);

	/**
	 * 根据新增业务对象插入用户我的题库错题记录
	 * @param bo 用户我的题库错题记录新增业务对象
	 * @return
	 */
	Boolean insertByAddBo(UserExamWrongRecordAddBo bo);

	/**
	 * 根据编辑业务对象修改用户我的题库错题记录
	 * @param bo 用户我的题库错题记录编辑业务对象
	 * @return
	 */
	Boolean updateByEditBo(UserExamWrongRecordEditBo bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

	Boolean remove_question(UserExamWrongRecordQueryBo bo);
}
